<template>
  <div>
    <!-- 年度开工率 -->
    <Echart
      :options="options"
      id="bottomLeftChart"
      height="480px"
      width="98%"
    ></Echart>
  </div>
</template>

<script>
import Echart from '@/common/echart'
export default {
  data () {
    return {
      options: {},
    };
  },
  components: {
    Echart,
  },
  props: {
    cdata: {
      type: Object,
      default: () => ({})
    },
  },
  watch: {
    cdata: {

      handler (newData) {
        this.options = {
          /*title : {
       text : '测试'
   },*/
          grid: {//调整工作区域，以符合需求（更多时候是为了取消图形周围过多的空白）
            //height: 800,//高度
            left: 45,//左边距
            top: 30,
            right:50,
            bottom:100,
          },
          textStyle:{
            color:"#FFF"
          },
          tooltip: {
            trigger: 'axis',
            axisPointer: { // 坐标轴指示器，坐标轴触发有效
              type: 'shadow' // 默认为直线，可选为：'line' | 'shadow'
            },
            formatter: function (params) {
              return params[0].name + '<br/>' + params[0].seriesName + ' : '
                  + params[0].value + '<br/>' + params[1].seriesName + ' : '
                  + (params[1].value + params[0].value);
            },
            extraCssText:'width:15em;height:8em;',//添加css设置tooltip宽高
            position:function(p){ //其中p为当前鼠标的位置
              return [p[0] + 10, p[1] - 10];
            },//设置tooltip显示位置
          },

          toolbox: {
            show: false,
            feature: {
              mark: {
                show: true
              },
              dataView: {
                show: true,
                readOnly: false
              },
              restore: {
                show: true
              },
              saveAsImage: {
                show: true
              }
            }
          },
          xAxis: [{
            type: 'category',
            data: newData.category,
          }, {
            type: 'category',
            show: false,
            boundaryGap: false,
            //  data: ['Cosco', 'CMA', 'APL', 'OOCL', 'Wanhai', 'Zim', "333"]//副轴类别，某些版本可以不要，
            //但低版本可能需要，另外做Plato时此类别在低版本时需要比主轴多一个值用来存储0值——Plato的起始点
          }],
          yAxis: [
            {
              max: 100,
              splitLine: { show: false },
              axisLine: {
                lineStyle: {
                  color: "#B4B4B4"
                }
              },

              axisLabel: {
                formatter: "{value} "
              }
            },
            {
              splitLine: { show: false },
              axisLine: {
                lineStyle: {
                  color: "#B4B4B4"
                }
              },
              axisLabel: {
                // formatter: "{value} "
                formatter: function(value) {
                  return value * 1 + '%';
                }
              }
            },
          ],
          series: [{
            name: 'Acutal Percent',
            type: 'bar',
            barCategoryGap: '0%',
            itemStyle: {
              normal: {
                color: function (obj) {
                  if (obj.dataIndex >= 0) {
                    return newData.colors[obj.dataIndex];
                  }
                },
                barBorderWidth: 1,
                barBorderRadius: 2,
                label: {
                  show: true,
                  position: 'top',
                  color:"#FFF"
                }
              }
            },
            data: newData.barData,//主轴数据 ——data
          }, {
            areaStyle: {
              normal: {
                color: {
                  x: 0,
                  y: 0,
                  x2: 0,
                  y2: 1,
                  colorStops: [{
                    offset: 0,
                    color: "#dc3881" // 0% 处的颜色
                  }, {
                    offset: 0.7,
                    color: "rgba(7,45,238,0)" // 100% 处的颜色
                  }],
                  globalCoord: false // 缺省为 false
                }
              }
            }, // 需要加上这一行
            name: 'Cumulative Percent',
            type: 'line',
            xAxisIndex: 1,
            yAxisIndex: 1,
            // data: [0,37, 44,55,100, 100,100],//副轴数据——percent
            data: newData.percentage,//副轴数据——percent
            itemStyle: {
              normal: {
                label: {
                  show: true,
                  position: 'bottom',
                  color:"#FFF",
                  backgroundColor:"blue",
                  padding:[5,3,3,3]
                }
              }
            },
            lineStyle: {
              color: '#dc3881', // 设置线的颜色为红色
              type: 'dashed' // dashed为虚线，dotted为点线
            }
          }

          ]
          // tooltip: {
          //   trigger: "axis",
          //   backgroundColor: "rgba(255,255,255,0.1)",
          //   axisPointer: {
          //     type: "shadow",
          //     label: {
          //       show: true,
          //       backgroundColor: "#7B7DDC"
          //     }
          //   }
          // },
          // legend: {
          //   data: ["不良数", "良率"],
          //   // data: ["", "不良数", ""],
          //   textStyle: {
          //     color: "#B4B4B4"
          //   },
          //   top: "0%"
          // },
          // grid: {
          //   top:"7%",
          //   x: "11%",
          //   width: "80%",
          //   height: "72%",
          //   y: "10%"
          // },
          // xAxis: {
          //   data: newData.category,
          //   axisLine: {
          //     lineStyle: {
          //       color: "#B4B4B4"
          //     }
          //   },
          //   axisTick: {
          //     show: false
          //   }
          // },
          // yAxis: [
          //   {
          //     splitLine: { show: false },
          //     axisLine: {
          //       lineStyle: {
          //         color: "#B4B4B4"
          //       }
          //     },
          //
          //     axisLabel: {
          //       formatter: "{value} "
          //     }
          //   },
          //   {
          //     splitLine: { show: false },
          //     axisLine: {
          //       lineStyle: {
          //         color: "#B4B4B4"
          //       }
          //     },
          //     axisLabel: {
          //       // formatter: "{value} "
          //       formatter: function(value) {
          //         return value * 100 + '%';
          //       }
          //     }
          //   },
          // ],
          // series: [
          //   {
          //     name: "良率",
          //     areaStyle: {
          //       normal: {
          //         color: {
          //           x: 0,
          //           y: 0,
          //           x2: 0,
          //           y2: 1,
          //           colorStops: [{
          //             offset: 0,
          //             color: "#dc3881" // 0% 处的颜色
          //           }, {
          //             offset: 0.7,
          //             color: "rgba(220,56,129,0)" // 100% 处的颜色
          //           }],
          //           globalCoord: false // 缺省为 false
          //         }
          //       }
          //     }, // 需要加上这一行
          //     type: "line",
          //     smooth: true,
          //     showAllSymbol: true,
          //     symbol: "emptyCircle",
          //     symbolSize: 8,
          //     yAxisIndex: 1,
          //     itemStyle: {
          //       normal: {
          //         color: "#F02FC2"
          //       }
          //     },
          //     data: newData.rateData,
          //   },
          //   {
          //     name: "不良数",
          //     type: "bar",
          //     barWidth: 80,
          //     itemStyle: {
          //       normal: {
          //         barBorderRadius: 5,
          //         color: new this.$echarts.graphic.LinearGradient(0, 0, 0, 1, [
          //           { offset: 0, color: "#956FD4" },
          //           { offset: 1, color: "#3EACE5" }
          //         ])
          //       }
          //     },
          //     data: newData.barData,
          //     label: {
          //       show: true,  // 显示标签
          //       position: 'top',  // 标签位置
          //       textStyle: {//数值样式
          //         fontSize: '20px',
          //         color: '##999'
          //       },
          //     },
          //   },
          //
          //   // {
          //   //   // name: "计划贯通",
          //   //   name: "完工数",
          //   //   type: "bar",
          //   //   barGap: "-100%",
          //   //   barWidth: 80,
          //   //   itemStyle: {
          //   //     normal: {
          //   //       barBorderRadius: 5,
          //   //       color: new this.$echarts.graphic.LinearGradient(0, 0, 0, 1, [
          //   //         { offset: 0, color: "rgba(156,107,211,0.8)" },
          //   //         { offset: 0.2, color: "rgba(156,107,211,0.5)" },
          //   //         { offset: 1, color: "rgba(156,107,211,0.2)" }
          //   //       ])
          //   //     }
          //   //   },
          //   //   z: -12,
          //   //   data: newData.lineData
          //   // },
          // ],
        }
      },
      immediate: true,
      deep: true
    },
  },
}
</script>